<?php
/*  Copyright 2002-2003 Patrick R. Michaud (pmichaud@pobox.com)
    This file is part of PmWiki; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published
    by the Free Software Foundation; either version 2 of the License
    (at your option) any later version.  See pmwiki.php for full details.

    This script enables markup of the form <<|TrailPage|>> to be 
    used to build "trails" through wiki documents.
    To enable this feature, just execute
   	include_once("scripts/trails.php");
    from local.php somewhere.
    Once enabled, the <<|TrailPage|>> markup is replaced with
    << PrevPage | TrailPage | NextPage >> on output.  TrailPage should
    contain either a bullet or number list defining the sequence of pages
    in the "trail".
   
    (09-Nov-2002) Note that Pm may revise this code substantially in the 
    near future, so don't depend on it as being stable just yet.
*/

$DoubleBrackets["/&lt;&lt;\\|(($PageNamePattern)|($WikiWordPattern))\\|&gt;&gt;/e"] 
  = 'MakeTrail("$1");';

function MakeTrail($word) {
  global $pagename,$Newline,$PageNamePattern,$WikiWordPattern;
  $trailname = $word;
  if (preg_match("/^($WikiWordPattern)$/",$trailname))
    $trailname = FmtPageName("\$Group.$trailname",$pagename);
  $trailpage = ReadPage($trailname);
  if ($trailpage) {
    $trailgroup = FmtPageName('$Group',$trailname);
    $trails = array_values(
      preg_grep("/^[#*]+\s*(($PageNamePattern)|($WikiWordPattern))/",
        explode($Newline,$trailpage['text'])));
    $tpa = preg_replace("/^[#*]+\s*(\S+).*/","$1",$trails);
    $tpa = preg_replace("/^($WikiWordPattern)$/","$trailgroup/$1",$tpa);
    $tpb = str_replace('/','.',$tpa);
    for($i=0;$i<count($tpb);$i++) {
      if ($tpb[$i] == $pagename) {
        if ($i>0) $prev = $tpa[$i-1];
        if ($i+1<count($tpb)) $next = $tpa[$i+1];
      }
    }
  }
  return "&lt;&lt; $prev | $word | $next &gt;&gt;";
}
    
?>
